/*
  Model-View-Controller demo program.
  Copyright (C) 2006 by Maria Litvin and Gary Litvin.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details:
    http://www.gnu.org/licenses/gpl.html.
*/

import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import javax.swing.Timer;

// Represents a timer that moves a car.
public class Clock implements ActionListener
{
  private Car car;
  private Timer timer;
  private int timeIncr;  // in milliseconds

  public Clock(Car car, int dt)
  {
    this.car = car;
    timeIncr = dt;
    timer = new Timer(timeIncr, this);
  }  

  // Starts this timer.
  public void start()
  {
    timer.start();
  }

  // Called automatically when the timer fires.
  public void actionPerformed(ActionEvent e)
  {
    car.move(timeIncr * 0.001);
  }
}
