/*
  Model-View-Controller demo program.
  Copyright (C) 2006 by Maria Litvin and Gary Litvin.

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details:
    http://www.gnu.org/licenses/gpl.html.
*/

import java.util.Observable;
import java.util.Observer;
import java.awt.Color;
import java.awt.Font;
import javax.swing.JPanel;
import javax.swing.JLabel;

// Represents a roadside display of a motorist's speed.
public class RoadsideDisplay extends JPanel
    implements Observer
{
  private JLabel speedDisplay;

  public RoadsideDisplay()
  {
    setBackground(Color.DARK_GRAY);
    Font largeFont = new Font("Monospaced", Font.BOLD, 24);

    JLabel label = new JLabel(" Your speed ");
    label.setFont(largeFont);
    label.setForeground(Color.WHITE);
    add(label);

    speedDisplay = new JLabel("    0  ");
    speedDisplay.setFont(largeFont);
    speedDisplay.setForeground(Color.YELLOW);
    add(speedDisplay);
  }  

  // Called when the model (a Car) notifies its observers that
  // it has moved.
  public void update(Observable model, Object arg)
  {
    int speed = (int)(Math.round(((Car)model).getSpeed() * 2.2));
    speedDisplay.setText(String.format("%5d  ", speed));
  }
}
